---
title: Calculator Forms for E-commerce
product: Form Library
description: Learn how to create calculator forms that instantly compute the total order costs based on predefined item prices and selected quantities. Build dynamic product order forms with item images and real-time calculations. Try out this free code example on JavaScript.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/how-to-create-calculator-form/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Calculator Forms for E-commerce (Vanilla JS)

Calculator forms are interactive e-forms that incorporate expression-based calculations into their functionality. They allow respondents to input data or make selections that are then processed in real-time to produce calculated results. For instance, a calculator form on a grocery shop website helps buyers determine the total cost of selected items. This demo shows how to build a calculator form that contains a catalog of item images with names and costs (vegetables in our example). Once a user selects an item they want to purchase, a related dropdown appears, allowing them to select the quantity. The total cost of all selected items is displayed at the bottom of the form and automatically updates with each modification.

## Arrange Elements on the Form

To build the layout described above, use [Panel](/form-library/examples/set-properties-on-multiple-questions-using-panel/) elements with an [Image Picker](/form-library/examples/image-picker-question/) and a [Dropdown](/form-library/examples/create-dropdown-menu-in-javascript/) questions inside. Each Image Picker should contain only one image and enable the [`multiSelect`](https://surveyjs.io/form-library/documentation/api-reference/image-picker-question-model#multiSelect) property to let respondents both select and unselect the image. Each Dropdown should become visible only when respondents select an image to which it is attached. Use the [`visibleIf`](https://surveyjs.io/form-library/documentation/api-reference/dropdown-menu-model#visibleIf) property to control the visibility.

## Perform Calculations

To calculate the price of each product, add an [Expression](/form-library/examples/expression-question-for-dynamic-form-calculations/) question to each Panel. Use this question multiply the price of one kilogram by the selected number of kilograms. Because this question will only be used in calculations, set its [`visible`](https://surveyjs.io/form-library/documentation/api-reference/expression-model#visible) property to `false`.

To compute the total price, create a [calculated value](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#calculated-values) that adds up all expression values. You can use an [HTML](/form-library/examples/questiontype-html/) question to display the calculated value. To exclude unselected products from the final calculation, set `SurveyModel`'s [`clearInvisibleValues`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#clearInvisibleValues) property to `"onHidden"`.

Refer to the survey JSON schema (the `json.js` file) for a code example.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "pages": [
    {
      "name": "page1",
      "title": "Vegetable Store",
      "elements": [
        {
          "type": "panel",
          "name": "cabbagePanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "cabbageImage",
              "title": "Cabbage",
              "description": "$2.50",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=d744127b-26e1-4b41-80ac-955b2a383621"
                }
              ],
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageHeight": 200,
              "maxImageWidth": 1000,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "cabbagePrice",
              "visible": false,
              "expression": "{cabbageWeight} * 2.50"
            },
            {
              "type": "dropdown",
              "name": "cabbageWeight",
              "visibleIf": "{cabbageImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "carrotPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "carrotImage",
              "title": "Carrot",
              "description": "$1.20",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=aaca9982-af66-4840-869e-fc2fc0b34bde"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "carrotPrice",
              "visible": false,
              "expression": "{carrotWeight} * 1.2"
            },
            {
              "type": "dropdown",
              "name": "carrotWeight",
              "visibleIf": "{carrotImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "pumpkinPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "pumpkinImage",
              "title": "Pumpkin",
              "description": "$3.00",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=26c5abf2-7eb2-4437-963e-03d49d8822d7"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "pumpkinPrice",
              "visible": false,
              "expression": "{pumpkinWeight} * 3.00"
            },
            {
              "type": "dropdown",
              "name": "pumpkinWeight",
              "visibleIf": "{pumpkinImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "pepperPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "pepperImage",
              "title": "Pepper",
              "description": "$4.50",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=68135162-1d85-4f5f-ba7b-3130274dc663"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "pepperPrice",
              "visible": false,
              "expression": "{pepperWeight} * 4.5"
            },
            {
              "type": "dropdown",
              "name": "pepperWeight",
              "visibleIf": "{pepperImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "cornPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "cornImage",
              "title": "Corn",
              "description": "$1.50",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=44c0fbcb-cf53-451f-a8f2-864dd7213d8e"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "cornPrice",
              "visible": false,
              "expression": "{cornWeight} * 1.5"
            },
            {
              "type": "dropdown",
              "name": "cornWeight",
              "visibleIf": "{cornImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "potatoPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "potatoImage",
              "title": "Potato",
              "description": "$0.90",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=51d53a3a-4d94-4b6e-b2fa-a48e7e7b44d4"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "potatoPrice",
              "visible": false,
              "expression": "{potatoWeight} * 0.9"
            },
            {
              "type": "dropdown",
              "name": "potatoWeight",
              "visibleIf": "{potatoImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "tomatoPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "tomatoImage",
              "title": "Tomato",
              "description": "$3.80",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=4c947e02-393b-4d18-b95b-77909de7ddeb"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "tomatoPrice",
              "visible": false,
              "expression": "{tomatoWeight} * 3.8"
            },
            {
              "type": "dropdown",
              "name": "tomatoWeight",
              "visibleIf": "{tomatoImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "lemonPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "lemonImage",
              "title": "Lemon",
              "description": "$2.20",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=a6de77e1-65de-4af5-bf09-3b8125bc140b"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "lemonPrice",
              "visible": false,
              "expression": "{lemonWeight} * 2.20"
            },
            {
              "type": "dropdown",
              "name": "lemonWeight",
              "visibleIf": "{lemonImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "html",
          "name": "totalPrice",
          "html": "<h4 style=\"font-weight:bold;margin-top:24px;margin-bottom:16px;text-align:right\">Total: ${total}</h4>"
        }
      ]
    }
  ],
  "calculatedValues": [
    {
      "name": "total",
      "expression": "{cabbagePrice} + {carrotPrice} + {pumpkinPrice} + {pepperPrice} + {cornPrice} + {tomatoPrice} + {potatoPrice} + {lemonPrice}",
      "includeIntoResult": true
    }
  ],
  "questionTitleLocation": "bottom",
  "clearInvisibleValues": "onHidden",
  "completeText": "PLACE ORDER",
  "widthMode": "responsive"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/angular.md)
- [React](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/jquery.md)


---
title: Calculator Forms for E-commerce
product: Form Library
description: Learn how to create calculator forms that instantly compute the total order costs based on predefined item prices and selected quantities. Build dynamic product order forms with item images and real-time calculations. Try out this free code example on JavaScript.
framework: Angular
source: https://surveyjs.io/form-library/examples/how-to-create-calculator-form/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Calculator Forms for E-commerce (Angular)

Calculator forms are interactive e-forms that incorporate expression-based calculations into their functionality. They allow respondents to input data or make selections that are then processed in real-time to produce calculated results. For instance, a calculator form on a grocery shop website helps buyers determine the total cost of selected items. This demo shows how to build a calculator form that contains a catalog of item images with names and costs (vegetables in our example). Once a user selects an item they want to purchase, a related dropdown appears, allowing them to select the quantity. The total cost of all selected items is displayed at the bottom of the form and automatically updates with each modification.

## Arrange Elements on the Form

To build the layout described above, use [Panel](/form-library/examples/set-properties-on-multiple-questions-using-panel/) elements with an [Image Picker](/form-library/examples/image-picker-question/) and a [Dropdown](/form-library/examples/create-dropdown-menu-in-javascript/) questions inside. Each Image Picker should contain only one image and enable the [`multiSelect`](https://surveyjs.io/form-library/documentation/api-reference/image-picker-question-model#multiSelect) property to let respondents both select and unselect the image. Each Dropdown should become visible only when respondents select an image to which it is attached. Use the [`visibleIf`](https://surveyjs.io/form-library/documentation/api-reference/dropdown-menu-model#visibleIf) property to control the visibility.

## Perform Calculations

To calculate the price of each product, add an [Expression](/form-library/examples/expression-question-for-dynamic-form-calculations/) question to each Panel. Use this question multiply the price of one kilogram by the selected number of kilograms. Because this question will only be used in calculations, set its [`visible`](https://surveyjs.io/form-library/documentation/api-reference/expression-model#visible) property to `false`.

To compute the total price, create a [calculated value](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#calculated-values) that adds up all expression values. You can use an [HTML](/form-library/examples/questiontype-html/) question to display the calculated value. To exclude unselected products from the final calculation, set `SurveyModel`'s [`clearInvisibleValues`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#clearInvisibleValues) property to `"onHidden"`.

Refer to the survey JSON schema (the `json.js` file) for a code example.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "pages": [
    {
      "name": "page1",
      "title": "Vegetable Store",
      "elements": [
        {
          "type": "panel",
          "name": "cabbagePanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "cabbageImage",
              "title": "Cabbage",
              "description": "$2.50",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=d744127b-26e1-4b41-80ac-955b2a383621"
                }
              ],
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageHeight": 200,
              "maxImageWidth": 1000,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "cabbagePrice",
              "visible": false,
              "expression": "{cabbageWeight} * 2.50"
            },
            {
              "type": "dropdown",
              "name": "cabbageWeight",
              "visibleIf": "{cabbageImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "carrotPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "carrotImage",
              "title": "Carrot",
              "description": "$1.20",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=aaca9982-af66-4840-869e-fc2fc0b34bde"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "carrotPrice",
              "visible": false,
              "expression": "{carrotWeight} * 1.2"
            },
            {
              "type": "dropdown",
              "name": "carrotWeight",
              "visibleIf": "{carrotImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "pumpkinPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "pumpkinImage",
              "title": "Pumpkin",
              "description": "$3.00",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=26c5abf2-7eb2-4437-963e-03d49d8822d7"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "pumpkinPrice",
              "visible": false,
              "expression": "{pumpkinWeight} * 3.00"
            },
            {
              "type": "dropdown",
              "name": "pumpkinWeight",
              "visibleIf": "{pumpkinImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "pepperPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "pepperImage",
              "title": "Pepper",
              "description": "$4.50",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=68135162-1d85-4f5f-ba7b-3130274dc663"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "pepperPrice",
              "visible": false,
              "expression": "{pepperWeight} * 4.5"
            },
            {
              "type": "dropdown",
              "name": "pepperWeight",
              "visibleIf": "{pepperImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "cornPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "cornImage",
              "title": "Corn",
              "description": "$1.50",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=44c0fbcb-cf53-451f-a8f2-864dd7213d8e"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "cornPrice",
              "visible": false,
              "expression": "{cornWeight} * 1.5"
            },
            {
              "type": "dropdown",
              "name": "cornWeight",
              "visibleIf": "{cornImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "potatoPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "potatoImage",
              "title": "Potato",
              "description": "$0.90",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=51d53a3a-4d94-4b6e-b2fa-a48e7e7b44d4"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "potatoPrice",
              "visible": false,
              "expression": "{potatoWeight} * 0.9"
            },
            {
              "type": "dropdown",
              "name": "potatoWeight",
              "visibleIf": "{potatoImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "tomatoPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "tomatoImage",
              "title": "Tomato",
              "description": "$3.80",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=4c947e02-393b-4d18-b95b-77909de7ddeb"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "tomatoPrice",
              "visible": false,
              "expression": "{tomatoWeight} * 3.8"
            },
            {
              "type": "dropdown",
              "name": "tomatoWeight",
              "visibleIf": "{tomatoImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "lemonPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "lemonImage",
              "title": "Lemon",
              "description": "$2.20",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=a6de77e1-65de-4af5-bf09-3b8125bc140b"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "lemonPrice",
              "visible": false,
              "expression": "{lemonWeight} * 2.20"
            },
            {
              "type": "dropdown",
              "name": "lemonWeight",
              "visibleIf": "{lemonImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "html",
          "name": "totalPrice",
          "html": "<h4 style=\"font-weight:bold;margin-top:24px;margin-bottom:16px;text-align:right\">Total: ${total}</h4>"
        }
      ]
    }
  ],
  "calculatedValues": [
    {
      "name": "total",
      "expression": "{cabbagePrice} + {carrotPrice} + {pumpkinPrice} + {pepperPrice} + {cornPrice} + {tomatoPrice} + {potatoPrice} + {lemonPrice}",
      "includeIntoResult": true
    }
  ],
  "questionTitleLocation": "bottom",
  "clearInvisibleValues": "onHidden",
  "completeText": "PLACE ORDER",
  "widthMode": "responsive"
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/vanillajs.md)


---
title: Calculator Forms for E-commerce
product: Form Library
description: Learn how to create calculator forms that instantly compute the total order costs based on predefined item prices and selected quantities. Build dynamic product order forms with item images and real-time calculations. Try out this free code example on JavaScript.
framework: React
source: https://surveyjs.io/form-library/examples/how-to-create-calculator-form/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Calculator Forms for E-commerce (React)

Calculator forms are interactive e-forms that incorporate expression-based calculations into their functionality. They allow respondents to input data or make selections that are then processed in real-time to produce calculated results. For instance, a calculator form on a grocery shop website helps buyers determine the total cost of selected items. This demo shows how to build a calculator form that contains a catalog of item images with names and costs (vegetables in our example). Once a user selects an item they want to purchase, a related dropdown appears, allowing them to select the quantity. The total cost of all selected items is displayed at the bottom of the form and automatically updates with each modification.

## Arrange Elements on the Form

To build the layout described above, use [Panel](/form-library/examples/set-properties-on-multiple-questions-using-panel/) elements with an [Image Picker](/form-library/examples/image-picker-question/) and a [Dropdown](/form-library/examples/create-dropdown-menu-in-javascript/) questions inside. Each Image Picker should contain only one image and enable the [`multiSelect`](https://surveyjs.io/form-library/documentation/api-reference/image-picker-question-model#multiSelect) property to let respondents both select and unselect the image. Each Dropdown should become visible only when respondents select an image to which it is attached. Use the [`visibleIf`](https://surveyjs.io/form-library/documentation/api-reference/dropdown-menu-model#visibleIf) property to control the visibility.

## Perform Calculations

To calculate the price of each product, add an [Expression](/form-library/examples/expression-question-for-dynamic-form-calculations/) question to each Panel. Use this question multiply the price of one kilogram by the selected number of kilograms. Because this question will only be used in calculations, set its [`visible`](https://surveyjs.io/form-library/documentation/api-reference/expression-model#visible) property to `false`.

To compute the total price, create a [calculated value](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#calculated-values) that adds up all expression values. You can use an [HTML](/form-library/examples/questiontype-html/) question to display the calculated value. To exclude unselected products from the final calculation, set `SurveyModel`'s [`clearInvisibleValues`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#clearInvisibleValues) property to `"onHidden"`.

Refer to the survey JSON schema (the `json.js` file) for a code example.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "pages": [
    {
      "name": "page1",
      "title": "Vegetable Store",
      "elements": [
        {
          "type": "panel",
          "name": "cabbagePanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "cabbageImage",
              "title": "Cabbage",
              "description": "$2.50",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=d744127b-26e1-4b41-80ac-955b2a383621"
                }
              ],
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageHeight": 200,
              "maxImageWidth": 1000,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "cabbagePrice",
              "visible": false,
              "expression": "{cabbageWeight} * 2.50"
            },
            {
              "type": "dropdown",
              "name": "cabbageWeight",
              "visibleIf": "{cabbageImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "carrotPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "carrotImage",
              "title": "Carrot",
              "description": "$1.20",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=aaca9982-af66-4840-869e-fc2fc0b34bde"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "carrotPrice",
              "visible": false,
              "expression": "{carrotWeight} * 1.2"
            },
            {
              "type": "dropdown",
              "name": "carrotWeight",
              "visibleIf": "{carrotImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "pumpkinPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "pumpkinImage",
              "title": "Pumpkin",
              "description": "$3.00",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=26c5abf2-7eb2-4437-963e-03d49d8822d7"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "pumpkinPrice",
              "visible": false,
              "expression": "{pumpkinWeight} * 3.00"
            },
            {
              "type": "dropdown",
              "name": "pumpkinWeight",
              "visibleIf": "{pumpkinImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "pepperPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "pepperImage",
              "title": "Pepper",
              "description": "$4.50",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=68135162-1d85-4f5f-ba7b-3130274dc663"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "pepperPrice",
              "visible": false,
              "expression": "{pepperWeight} * 4.5"
            },
            {
              "type": "dropdown",
              "name": "pepperWeight",
              "visibleIf": "{pepperImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "cornPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "cornImage",
              "title": "Corn",
              "description": "$1.50",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=44c0fbcb-cf53-451f-a8f2-864dd7213d8e"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "cornPrice",
              "visible": false,
              "expression": "{cornWeight} * 1.5"
            },
            {
              "type": "dropdown",
              "name": "cornWeight",
              "visibleIf": "{cornImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "potatoPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "potatoImage",
              "title": "Potato",
              "description": "$0.90",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=51d53a3a-4d94-4b6e-b2fa-a48e7e7b44d4"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "potatoPrice",
              "visible": false,
              "expression": "{potatoWeight} * 0.9"
            },
            {
              "type": "dropdown",
              "name": "potatoWeight",
              "visibleIf": "{potatoImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "tomatoPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "tomatoImage",
              "title": "Tomato",
              "description": "$3.80",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=4c947e02-393b-4d18-b95b-77909de7ddeb"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "tomatoPrice",
              "visible": false,
              "expression": "{tomatoWeight} * 3.8"
            },
            {
              "type": "dropdown",
              "name": "tomatoWeight",
              "visibleIf": "{tomatoImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "panel",
          "name": "lemonPanel",
          "elements": [
            {
              "type": "imagepicker",
              "name": "lemonImage",
              "title": "Lemon",
              "description": "$2.20",
              "choices": [
                {
                  "value": "image",
                  "imageLink": "https://api.surveyjs.io/private/Surveys/files?name=a6de77e1-65de-4af5-bf09-3b8125bc140b"
                }
              ],
              "colCount": 1,
              "imageFit": "cover",
              "minImageHeight": 200,
              "maxImageWidth": 1000,
              "maxImageHeight": 200,
              "multiSelect": true
            },
            {
              "type": "expression",
              "name": "lemonPrice",
              "visible": false,
              "expression": "{lemonWeight} * 2.20"
            },
            {
              "type": "dropdown",
              "name": "lemonWeight",
              "visibleIf": "{lemonImage} = ['image']",
              "titleLocation": "hidden",
              "choices": [ 1, 2, 3, 4, 5 ],
              "placeholder": "Select weight (kg)",
              "allowClear": false
            }
          ],
          "startWithNewLine": false,
          "minWidth": "320px"
        },
        {
          "type": "html",
          "name": "totalPrice",
          "html": "<h4 style=\"font-weight:bold;margin-top:24px;margin-bottom:16px;text-align:right\">Total: ${total}</h4>"
        }
      ]
    }
  ],
  "calculatedValues": [
    {
      "name": "total",
      "expression": "{cabbagePrice} + {carrotPrice} + {pumpkinPrice} + {pepperPrice} + {cornPrice} + {tomatoPrice} + {potatoPrice} + {lemonPrice}",
      "includeIntoResult": true
    }
  ],
  "questionTitleLocation": "bottom",
  "clearInvisibleValues": "onHidden",
  "completeText": "PLACE ORDER",
  "widthMode": "responsive"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/how-to-create-calculator-form/vanillajs.md)
